import os
import sys

def remove_one_parentheses(text):
    for i, l in enumerate(text):
        if l == "(":
            if text[i-1] in ["a", "b", "c", "d"]:
                open_index = i
                close_index = i+text[i:].find(")")
                text = text[0:open_index]+text[close_index+1:]
                return True, text
    return False, text


def remove_parentheses(text):
    condition = True
    while condition:
        condition, text = remove_one_parentheses(text)
    return text


def count_flops(t):
    return t.count("+")+t.count("*")+t.count("-")+t.count("/")


def count_arrays(t):
    t = t.replace("*", " ")
    t = t.replace("+", " ")
    t = t.replace("-", " ")
    t = t.replace("/", " ")
    t = t.replace("(", " ")
    t = t.replace(")", " ")
    variables = [var for var in t.split() if "p" not in var]
    return len(set(variables))


# Input File comprovations
if len(sys.argv) != 2:
    print "Must put a input file."
    exit(1)

filename = sys.argv[1]
if not os.path.isfile(filename):
    print filename,"is not a valid input file."
    exit(1)


with open(filename, "r") as f:
    data = [l for l in f]
    equation = [l for l in data if l.count("! Line (do not remove this comment )")][0]
    equation = equation.split("!")[0].strip().lower()
    outp, inp = equation.split("=")

    # Remove array indices in input parameters
    inp = remove_parentheses(inp)

    # Count number of flops in input parameters
    FLOP = count_flops(inp)
    LD = count_arrays(inp)
    SR = 1

    # Compute flop per byte ratio
    FlopPerByte = FLOP/(8.*(LD+SR))
    print FlopPerByte

